> For the complete documentation index, see [llms.txt](https://docs.layerlens.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.layerlens.ai/13.1-sdk-and-apis/migrating-sdk-versions.md).

# Migrating SDK versions

The SDK follows semver. Breaking changes are major-version bumps. Within a major, additions only.

## v1.2 → v1.3

**Additions:**

* `client.judge_optimizations` (GEPA) — new namespace
* `client.trace_evaluations.create(..., trace_set={...})` — new param

No breaking changes. Upgrade is drop-in.

## v1.1 → v1.2

**Additions:**

* `client.spaces` — new namespace
* Improved retry semantics

No breaking changes.

## Pinning

Production: pin exact version.

```bash
pip install layerlens --extra-index-url https://sdk.layerlens.ai/package==1.3.0
```

Development: pin the minor.

```bash
pip install "layerlens>=1.3.0,<1.4.0"
```

## See also

* [Versioning](https://github.com/LayerLens/gitbook-full/blob/main/13-reference/sdk-python/versioning.md)
* [SDK release notes](https://github.com/LayerLens/gitbook-full/blob/main/13-reference/sdk-python/release-notes-sdk.md)
* [Platform release notes](/6.-build-wire-your-code/sdk-python.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.layerlens.ai/13.1-sdk-and-apis/migrating-sdk-versions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
